<?php
function searchNestedArray($array, $key, $value)
{
    $results = array();

    if (is_array($array)) {
        if (isset($array[$key]) && $array[$key] == $value) {
            $results[] = $array;
        }

        foreach ($array as $subarray) {
            $results = array_merge($results, searchNestedArray($subarray, $key, $value));
        }
    }

    return $results;
}


function pruefeLieferzonenPLZ($helper, $plz2, $agws_freeVA_PLZ_plzarr, $agws_freeVA_PLZ_vname, $agws_freeVA_PLZ_mwert, $agws_freeVA_PLZ_view, $oVersandart_arr2, $agwsfreeVA_PLZ_WKWert)
{
    $agwsfreeVA_PLZ_LA_PLZ = $plz2;
    $agwsfreeVA_PLZ_flag = false;

    /** Lsche event. Leerzeichen **/
    $agws_freeVA_PLZ_str = $agws_freeVA_PLZ_plzarr;
    $agws_freeVA_PLZ_vname_str = $agws_freeVA_PLZ_vname;

    /** Hole Versandart-ID zu Zonen-Versandart in ein Array**/
    $agws_freeVA_PLZ_vname_arr = explode(",", $agws_freeVA_PLZ_vname_str);
    $agws_freeVA_PLZ_vname_id = array();

    foreach ($agws_freeVA_PLZ_vname_arr as $agws_freeVA_PLZ_vname) {
        $sql = "SELECT tversandart.kVersandart
					FROM tversandart
					WHERE tversandart.cName = '" . trim($agws_freeVA_PLZ_vname) . "'";
        ($helper->isShop4()) ?
            $agws_freeVA_PLZ_vname_id[] = Shop::DB()->query($sql, 8) :
            $agws_freeVA_PLZ_vname_id[] = $GLOBALS['DB']->executeQuery($sql, 8);
    }
    
    /** Baue PLZ-Array mit Komma-Trennung **/
    $agws_freeVA_PLZ_arr = explode(",", $agws_freeVA_PLZ_str);

    foreach ($agws_freeVA_PLZ_arr as $agws_freeVA_PLZ) {
        if (strpos($agws_freeVA_PLZ, "-") !== false) {
            $agws_freeVA_PLZ_arr2 = explode("-", $agws_freeVA_PLZ);
            $agws_freeVA_PLZ_start = $agws_freeVA_PLZ_arr2[0];
            $agws_freeVA_PLZ_ende = $agws_freeVA_PLZ_arr2[1];
        } else {
            $agws_freeVA_PLZ_start = $agws_freeVA_PLZ;
            $agws_freeVA_PLZ_ende = $agws_freeVA_PLZ;
        }

        if ((int)$agwsfreeVA_PLZ_LA_PLZ >= (int)$agws_freeVA_PLZ_start && (int)$agwsfreeVA_PLZ_LA_PLZ <= (int)$agws_freeVA_PLZ_ende) {
            $agwsfreeVA_PLZ_flag = true;
            break;
        }
    }

    if (isset($oVersandart_arr2) && ($agwsfreeVA_PLZ_flag === false || round($agwsfreeVA_PLZ_WKWert, 2) < round($agws_freeVA_PLZ_mwert, 2))) {
        $cnt = count($oVersandart_arr2);
        for ($i = 0; $i < $cnt; $i++) {
            $oVersandart_arr2_search = searchNestedArray($agws_freeVA_PLZ_vname_id, 'kVersandart', $oVersandart_arr2[$i]->kVersandart);
            if (count($oVersandart_arr2_search) > 0) {
                unset($oVersandart_arr2[$i]);
                continue;
            }
        }
        $oVersandart_arr2 = array_values($oVersandart_arr2);
    }

    if (isset($oVersandart_arr2) && ($agwsfreeVA_PLZ_flag === true && round($agwsfreeVA_PLZ_WKWert, 2) >= round($agws_freeVA_PLZ_mwert, 2) && $agws_freeVA_PLZ_view == 1)) {
        $cnt = count($oVersandart_arr2);
        for ($i = 0; $i < $cnt; $i++) {
            $oVersandart_arr2_search = searchNestedArray($agws_freeVA_PLZ_vname_id, 'kVersandart', $oVersandart_arr2[$i]->kVersandart);
            if (count($oVersandart_arr2_search) > 0) {
                (isset($oVersandart_arr2[$i]->cHinweis)) ?
                    $oVersandart_arr2[$i]->cHinweis .= "<br>" . $agws_freeVA_PLZ_plzarr :
                    $oVersandart_arr2[$i]->cHinweis = $agws_freeVA_PLZ_plzarr;
                (isset($oVersandart_arr2[$i]->angezeigterHinweistext)) ?
                    $oVersandart_arr2[$i]->angezeigterHinweistext[$_SESSION['cISOSprache']] .= "<br>" . $agws_freeVA_PLZ_plzarr :
                    $oVersandart_arr2[$i]->angezeigterHinweistext[$_SESSION['cISOSprache']] = $agws_freeVA_PLZ_plzarr;
            }
        }
    }

    return $oVersandart_arr2;
}